#ifndef	_HOOKDBT_H
#define	_HOOKDBT_H
/*
 *	hookdbt.h
 */

#define DISK_BASE_TABLE_INT_VECTOR	0x1e

/*
 *	Most conventional references document 11 bytes for the Disk Base Table,
 *	however at least one current IBM BIOS appears to use 12 so this value is
 *	defined as slightly larger.  It shouldn't cause any problems since
 *	a) we don't modify the original memory that the table occupied
 *	b) It should only be accessed via the vector Int 1Eh anyway
 */
#define	DISK_BASE_TABLE_SIZE	16

typedef struct disk_base_table_struct
{
	Word	orig_segment;	/*  Old Int 1Eh pointer  */
	Word	orig_offset;
	Byte	table[DISK_BASE_TABLE_SIZE];

} Disk_Base_Table;

#if __STDC__
#  define _Cdecl
#else
#  define _Cdecl  cdecl
#endif

#ifdef __cplusplus
extern "C" {
#endif

/*  Global public functions in hookdbt.c  */
Bool _Cdecl hook_disk_base_table (Disk_Base_Table *dbt);
Bool _Cdecl unhook_disk_base_table (Disk_Base_Table *dbt);
void _Cdecl msdos_get_interrupt_vector (Byte int_num, Word *segment, Word *offset);
void _Cdecl	msdos_set_interrupt_vector (Byte int_num, Word segment, Word offset);

#ifdef __cplusplus
}
#endif

#endif	/* !_HOOKDBT_H */
